#!/usr/bin/python
# -*- coding: utf-8 -*-

# checkUpdate.py
#
# This file is part of BotMU
#
# Author: Raphaël Perraudeau <r.perraudeau@gmail.com>
# Copyright: 2011 Raphaël Perraudeau <r.perraudeau@gmail.com>
# Licence: GNU/GPL
#
# Home page: <http://botmu.sourceforge.net/>


# Pyqt4
from PyQt4.QtCore import *
from PyQt4.QtGui import *

#Perso

from commonFunctions import *
from httpReq import *


#############################################################################
class checkIfUpdate(QThread):
	#========================================================================
	def __init__(self, parent=None):
		super(checkIfUpdate,self).__init__(parent)
		self.parent = parent
	
	#========================================================================
	def run(self):
		#mise à jour quotidienne
		if(self.parent.checkupdateDelay==0):
			dateLastCheck = datetime.datetime.fromtimestamp(self.parent.checkupdateLast).timetuple()
			dateToday = datetime.datetime.today().timetuple()
			if(dateLastCheck[0]<=dateToday[0] and dateLastCheck[1]<=dateToday[1]):
				if(dateLastCheck[2]<dateToday[2]):
					updateNeed = 1
				else:
					updateNeed = 0
			else:
				updateNeed = 0
		#mise à jour hebdomadaire
		if(self.parent.checkupdateDelay==1):
			dateLastCheck = datetime.datetime.fromtimestamp(self.parent.checkupdateLast).isocalendar()
			dateToday = datetime.datetime.today().isocalendar()
			if(dateLastCheck[0] <= dateToday[0]):
				if(dateLastCheck[1] < dateToday[1]):
					updateNeed = 1
				else:
					updateNeed = 0
			else:
				updateNeed = 0
		#mise à jour mensuelle
		if(self.parent.checkupdateDelay==2):
			dateLastCheck = datetime.datetime.fromtimestamp(self.parent.checkupdateLast).timetuple()
			dateToday = datetime.datetime.today().timetuple()
			if(dateLastCheck[0]<=dateToday[0]):
				if(dateLastCheck[1]<dateToday[1]):
					updateNeed = 1
				else:
					updateNeed = 0
			else:
				updateNeed = 0
			
		if(updateNeed):
			try:
				saveOptionsFile(self.parent.configDir, self.parent.defaultDir, self.parent.checkUpdate, self.parent.checkupdateDelay, time.time(), self.parent.limit, self.parent.verbose)
				httpreq = httpReq(self.parent.configDir)
				httpreq.defineUseragent(platform.system())
				httpreq.defineProxy(self.parent.proxy)
				httpreq.defineVerbose(int(self.parent.verbose))
				page = httpreq.getPage("http://botmu.sourceforge.net/checkupdate-%s.html" % self.parent.parent.version)
			
				updateInfos = page.read().split("<updateCheck>")[1].split("</updateCheck>")[0]
				updateNeeded = updateInfos.split("<needed>")[1].split("</needed>")[0]
				if(updateNeeded!="0"):
					updateVersion = updateInfos.split("<version>")[1].split("</version>")[0]
					updateLink = updateInfos.split("<updateLink>")[1].split("</updateLink>")[0]
					updateChangelog = updateInfos.split("<changelog>")[1].split("</changelog>")[0]
					up = self.showLastUpdate(updateVersion, updateLink, updateChangelog)
			except:
				logError("checkUpdate - 1", sys.exc_info()[0], sys.exc_info()[1])
				
	def showLastUpdate(self, updateVersion, updateLink, updateChangelog):
		self.emit(SIGNAL("showLastUpdate(PyQt_PyObject)"), 
											  [updateVersion, updateLink, updateChangelog])
